#include "stdafx.h"

#include "FileOperation.h"

union
{
	wchar_t wc;
	char sc[2];
} dByte;


/* 
 * nUnicode :
 *	0: MBCS
 *	2: UTF-16LE BOM
 *	4: UTF-16BE BOM
 *	6: UTF-8 BOM
 *	(2,4,6 +1 : NO-BOM)
 */

LPWSTR FileOpen(LPCWSTR cszFilePath,int nUnicode,int nEncoding)
{

	HANDLE hFile=NULL;
	char * arText=NULL;
	static wchar_t * pszText=NULL;
	try
	{
		hFile = CreateFile(cszFilePath,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(hFile==NULL)
			throw 1;

		DWORD dFileSize=NULL;

		BYTE arBOM[4]="";

		if(ReadFile(hFile,arBOM,4,&dFileSize,0)==0)
			throw 2;

		

		//BOM ĺ
		int nJump=0;
		if(arBOM[0]==0xFF &&
			arBOM[1]==0xFE)
		{
			nUnicode=3;
			nJump=2;
		}
		else if(arBOM[0]==0xFE &&
				arBOM[1]==0xFF)
		{
			nUnicode=5;
			nJump=2;
		}
		else if(arBOM[0]==0xEF &&
				arBOM[1]==0xBB &&
				arBOM[2]==0xBF)
		{
			nUnicode=7;
			nJump=3;
		}
		SetFilePointer(hFile,nJump,NULL,FILE_BEGIN); //ġ 

		if((dFileSize=GetFileSize(hFile,NULL))==NULL)
			throw 3;

		arText = new char[dFileSize+4];
		memset(arText,0x00,dFileSize+4);

		if(ReadFile(hFile,arText,dFileSize,&dFileSize,NULL)==NULL) // !
			throw 4;

		if(nUnicode==7 || nUnicode==0  || nUnicode==6)
		{
			//MBCS
			//켱 \r ó
			{
				int i=0;
				int j=0;
				while(1)
				{
					if(arText[i+j]=='\r')
					{
						j++;
					}
					else if(arText[i+j]=='\0')
					{
						arText[i++]='\0';
						break;
					}
					else
					{
						arText[i]=arText[i+j];
						i++;
					}
				}

				pszText = new wchar_t[dFileSize+6];
				memset(pszText,0x00,dFileSize+6);

				if(nUnicode==7 || nUnicode==6)
					nEncoding=CP_UTF8;

				MultiByteToWideChar(nEncoding,NULL,arText,-1,pszText,dFileSize+6);
			}
		}
		else
		{
			//Unicode LE or BE

			pszText = new wchar_t[dFileSize/2+100];
			
			//ȯ ۾ \r ÿ
			int i=0;
			int j=0;

			int k=0;
			int l=1;
			if(nUnicode == 5) //LE BEó
			{
				k=1;
				l=0;
			}

			while(1)
			{
				dByte.sc[k] = arText[i++];
				dByte.sc[l] = arText[i++];
				if(dByte.wc == L'\0')
				{
					pszText[j++]=L'\0';
					break;
				}
				else if(dByte.wc != L'\r')
				{
					pszText[j++]=dByte.wc;
				}
			}
		}

		delete[] arText;

		CloseHandle(hFile);
		return pszText;
	}
	catch(int nErr)
	{
		delete[] arText;
		CloseHandle(hFile);
		delete[] pszText;
		return NULL;
	}
}
LPWSTR FileOpen(LPCWSTR cszFilePath,vector<wstring>* arText,int nUnicode,int nEncoding)
{
	arText->clear();
	LPWSTR szText=NULL;
	szText = FileOpen(cszFilePath,nUnicode,nEncoding);

	int i=0;
	int j=0;
	if(szText==NULL)
		return 0;
	while(1)
	{
		if(szText[j]==L'\0'||szText[j]=='\n')
		{
			wchar_t * pszTemp = new wchar_t[j-i+2];
			memset(pszTemp,0x00,j-i+2);

			lstrcpyn(pszTemp,szText+i,j-i+1);
			wstring strTemp=pszTemp;

			delete[] pszTemp;
			arText->push_back(strTemp);

			i=j+1;
			if(szText[j]==L'\0')
				break;
		}
		j++;
	}
	delete[] szText;
	return 0;
}

void FileSave(LPCWSTR cszFilePath,LPCWSTR pszText,int nUnicode,int nEncoding)
{
	HANDLE hFile=NULL;
	char * arText=NULL;
	DWORD nDestSize=0;
	try
	{
		hFile = CreateFile(cszFilePath,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(hFile==NULL)
			throw 1;

		//޸ 
		DWORD nSrcSize=lstrlenW(pszText);
		arText = new char[nSrcSize*3+100]; //ġ 3
		memset(arText,0x00,nSrcSize*3+100);

		/* nUnicode
	0: MBCS
	2: UTF-16LE BOM
	4: UTF-16BE BOM
	6: UTF-8 BOM
	(2,4,6 +1 : NO-BOM)
	*/
		int nSrc=0;
		bool bCross0=0;
		bool bCross1=1;
		bool bLE=false;
		bool bBOM=false;
		switch(nUnicode)
		{
		case 2:
			//UTF-16LE BOM
			bLE=true;
		case 4:
			//UTF-16BE BOM
			bBOM=true;
		case 3:
			//UTF-16LE
			if(nUnicode==3)
				bLE=true;
		case 5:
			//UTF-16BE

			//۾ 

			//Ʈ ũν۾
			if(!bLE)
			{
				bCross0=1;
				bCross1=0;
			}

			//BOM
			if(bBOM)
			{
				dByte.wc=(DWORD)0xFEFF;
				arText[nDestSize++]=(char)dByte.sc[bCross0];
				arText[nDestSize++]=(char)dByte.sc[bCross1];
			}

			while(pszText[nSrc]!=L'\0')
			{
				if(pszText[nSrc]==L'\n')
				{
					dByte.wc=L'\r';
					arText[nDestSize++]=(char)dByte.sc[bCross0];
					arText[nDestSize++]=(char)dByte.sc[bCross1];

					dByte.wc=L'\n';
					arText[nDestSize++]=(char)dByte.sc[bCross0];
					arText[nDestSize++]=(char)dByte.sc[bCross1];
				}
				else
				{
					dByte.wc=pszText[nSrc];
					arText[nDestSize++]=(char)dByte.sc[bCross0];
					arText[nDestSize++]=(char)dByte.sc[bCross1];
				}
				nSrc++;
			}

			break;

		case 6:
			//UTF-8 BOM
			nEncoding=CP_UTF8;
			arText[nDestSize++]=(char)0xEF;
			arText[nDestSize++]=(char)0xBB;
			arText[nDestSize++]=(char)0xBF;
			bBOM=true;
		default:
			//MBCS or Default UTF-8 (NO BOM)
			nUnicode=0;
			DWORD dByte=nSrcSize*3+100;
			if(bBOM)
				nDestSize=WideCharToMultiByte(nEncoding,0,pszText,-1,arText+3,dByte-3,0,0)+3;
			else
				nDestSize=WideCharToMultiByte(nEncoding,0,pszText,-1,arText,dByte,0,0);

			int nRet=0;

			for(DWORD i=0;i<nDestSize;i++)
			{
				if(arText[i]=='\n')
				{
					nRet++;
				}
			}

			nDestSize+=nRet;

			for(int i=nDestSize-1-nRet;i>=0;i--)
			{
				if(arText[i]=='\n')
				{
					arText[i+nRet--]='\n';
					arText[i+nRet]='\r';
				}
				else
				{
					if(nRet==0)
						break;

					arText[i+nRet]=arText[i];
				}
			}
			
			break;
		}
		if(nUnicode==0)
			nDestSize--;
		WriteFile(hFile,arText,nDestSize,&nDestSize,0);

		delete[]arText;
		CloseHandle(hFile);

	}
	catch (int nErr)
	{
		delete[]arText;
		CloseHandle(hFile);
	}
}

void FileSave(LPCWSTR cszFilePath,vector<wstring>* arText,int nUnicode,int nEncoding)
{
	wstring strTemp;

	int nSize = arText->size();
	for(int i=0;i<nSize-1;i++)
	{
		strTemp += arText->at(i);
		strTemp += L'\n';
	}
	if(nSize>0)
		strTemp += arText->at(arText->size()-1);

	FileSave(cszFilePath,strTemp.c_str(),nUnicode,nEncoding);
}